#
# Sensus Consulting Ltd (C) 1997-1998
# Matt Newman <matt@sensus.org>
#
# Shell of a Win95 Explorer-like application
#
#INDEX\
proc tk++::ExplorerShell {} {}

package require tk++

class tk++::ExplorerShell {
	inherit tk++::App

	constructor {args} {}

	public {
		method selection {args}
	}
	protected {
		method activate {id mode}
		method context {id x y}
		method expand {id mode}
		method treeCallback {id args}
		method listCallback {tag}
	}

	common aboutString [format {
Tcl/Tk ExplorerShell
Version 0.9

Copyright %s 1997-1998 Sensus Consulting Ltd.

Matt Newman <matt@sensus.org>} "\251"]
}
body tk++::ExplorerShell::constructor {args} {

	configure -geometry 700x400 -title "Tk++ Explorer"

	menubar add menu File -menu {
		command New		-command {NewWindow}
		command Console	-command {console show}
		separator
		command Close	-command {closeApp 0}
		command Exit	-underline 1 -command {exitApp 0}
	}
	menubar add menu Edit -menu {
		command Undo	-command {%W selection undo}
		separator
		command Cut		-command {%W selection cut} -underline 2 -accel {Ctrl+X}
		command Copy	-command {%W selection copy} -accel {Ctrl+C}
		command Paste	-command {%W selection paste} -accel {Ctrl+V}
		separator
		command {Select All}	-command {%W selection select *} \
						-underline 7 -accel {Ctrl+A}
	}
	menubar add menu View -menu {
		checkbutton Toolbar			-command {%W selection undo}
		checkbutton {Status Bar}	-command {%W selection undo} -underline 7
		separator
		radiobutton	{Large Icons}	-underline 4
		radiobutton	{Small Icons}	-underline 1
		radiobutton	{List}
		radiobutton	{Details}
	}
	menubar add menu Help -menu {
		command About	-command {About [set [info class]::aboutString]}
	}
	itk_component add leftlabel {
		label $itk_component(left).lab -anchor w -relief sunken \
					-borderwidth 1 -width 1
	} {
		keep -background -font
		keep -background -font -text
		rename -text -leftlabel leftLabel LeftLabel
	}
	itk_component add rightlabel {
		label $itk_component(right).lab -anchor w -relief sunken \
					-borderwidth 1 -width 1
	} {
		keep -background -font -text
		rename -text -rightlabel rightLabel RightLabel
	}
	itk_component add listview {
		tk++::ListView $itk_component(right).lv \
						-relief sunken -borderwidth 1 \
						-width 10 -height 10 -highlightthickness 0 \
						-command [code -namespace [info class] $this listCallback]
	}
	itk_component add treeview {
		tk++::TreeView $itk_component(left).tree -relief sunken -borderwidth 1 \
						-command [code -namespace [info class] $this treeCallback]
	}
	itk_component add contextMenu {
		::menu $itk_interior.context -tearoff 0
	} {
		keep -font -background
	}

	set pad 1
	pack $itk_component(leftlabel) -side top -anchor w -fill x \
									-padx $pad -pady $pad
	pack $itk_component(treeview) -side bottom -anchor nw -fill both \
									-expand yes -padx $pad -pady $pad

	pack $itk_component(rightlabel) -side top -anchor w -fill x \
									-padx $pad -pady $pad
	pack $itk_component(listview) -side bottom -anchor nw -fill both \
									-expand yes -padx $pad -pady $pad

	$itk_component(rightlabel) conf -text {All Folders}

	eval itk_initialize $args
}
body tk++::ExplorerShell::listCallback {tag} {
	status "\"$tag\" double-clicked"
}
body tk++::ExplorerShell::treeCallback {id event args} {
	if {![info exists itk_component(treeview)]} return
	eval [info class]::$event $id $args
}
body tk++::ExplorerShell::activate {id mode} {
	status activate $id $mode
}
body tk++::ExplorerShell::expand {id mode} {
	status expand $id $mode
}
body tk++::ExplorerShell::context {id x y} {
	status context $id $x $y
}
