#
# Sensus Consulting Ltd, Copyright 1997-1998
#
# Matt Newman <matt@sensus.org>
#
package require tk++

class tk++::Listbox++ {
	inherit tk++::Listbox

	constructor {args} { eval itk_initialize $args }

	public {
		method insert {args}
		method delete {args}
	}
	itk_option define -listvar listVar ListVar "" {_reconfig}

	protected {
		method _sync {}
		method _reconfig {args}

		variable olistvar ""
	}
}
body tk++::Listbox++::insert {args} {
	eval chain $args
	_sync
}
body tk++::Listbox++::delete {args} {
	eval chain $args
	_sync
}
body tk++::Listbox++::_sync {} {
	if {$itk_option(-listvar) == ""} {return}
	upvar #0 $itk_option(-listvar) lvar
	::trace vdelete $olistvar w [code $this _reconfig]
	::set lvar [get 0 end]
	::trace variable $olistvar w [code $this _reconfig]
}
body tk++::Listbox++::_reconfig {args} {
	if {$itk_option(-listvar) != "" && \
		[string match ::* $itk_option(-listvar)]==0} {
		set itk_option(-listvar) "::$itk_option(-listvar)"
	}
	if {$olistvar != $itk_option(-listvar)} {
		if {$olistvar != ""} {
			::trace vdelete $olistvar w [code $this _reconfig]
		}
		set olistvar $itk_option(-listvar)
		if {$itk_option(-listvar) != ""} {
			::trace variable $itk_option(-listvar) w [code $this _reconfig]
		}
	}
	if {$itk_option(-listvar) == ""} {return}

	upvar #0 $itk_option(-listvar) lvar

	set active [get active]
	set selected {}
	set items [get 0 end]
	foreach idx [curselection] {
		lappend selected [lindex $items $idx]
	}
	[super]::delete 0 end
	if {[llength $lvar]==0}	{
		return
	}
	eval [super]::insert end $lvar
	set idx [lsearch $lvar $active]
	if {$idx != -1} {
		# Reinstate the active index
		activate $idx
	}
	foreach item $selected {
		set idx [lsearch $lvar $item]
		if {$idx != -1} {
			selection set $idx
		}
	}
}
