#
# Sensus Consulting Ltd (c) 1997-1998
# Matt Newman <matt@sensus.org>
#
# Basic Tk++ class for menu, to allow for subclassing.
#
#INDEX\
proc tk++::Menu {} {}

package require tk++

class tk++::Menu {
    inherit itk::Archetype

    constructor {args} {}
    destructor {}

    public method activate {index} {}
    public method add {type args} {}
    public method delete {index1 args} {}
    public method entrycget {index option} {}
    public method entryconfigure {index args} {}
    public method index {index} {}
    public method insert {index type args} {}
    public method invoke {index} {}
    public method post {x y} {}
    public method postcascade {index} {}
    public method type {index} {}
    public method unpost {} {}
    public method yposition {index} {}

    private variable itk_hull		;# No init
}
body tk++::Menu::constructor {args} {
    #
    #  Create a window with the same name as this object
    #
    set itk_hull [namespace tail $this]
    set itk_interior $itk_hull

    itk_component add hull {
		menu $itk_hull
    } {
		keep -activebackground -activeborderwidth -activeforeground
		keep -background -borderwidth -cursor -disabledforeground
		keep -font -foreground -postcommand -relief -selectcolor
		keep -takefocus -tearoff
    }
    bind itk-delete-$itk_hull <Destroy> "delete object $this"

    set tags [bindtags $itk_hull]
    bindtags $itk_hull [linsert $tags 0 itk-delete-$itk_hull]

    eval itk_initialize $args
}
body tk++::Menu::destructor {} {
    if {[winfo exists $itk_hull]} {
		set tags [bindtags $itk_hull]
		set i [lsearch $tags itk-delete-$itk_hull]
		if {$i >= 0} {
			bindtags $itk_hull [lreplace $tags $i $i]
		}
		::destroy $itk_hull
    }
}
body tk++::Menu::activate {index} {
    ${itk_hull}-itk_hull activate $index
}
body tk++::Menu::add {type args} {
    eval [list ${itk_hull}-itk_hull add $type] $args
}
body tk++::Menu::delete {index1 args} {
    eval [list ${itk_hull}-itk_hull delete $index1] $args
}
body tk++::Menu::entrycget {index option} {
    ${itk_hull}-itk_hull entrycget $index $option
}
body tk++::Menu::entryconfigure {index args} {
    eval [list ${itk_hull}-itk_hull entryconfigure $index] $args
}
body tk++::Menu::index {index} {
    ${itk_hull}-itk_hull index $index
}
body tk++::Menu::insert {index type args} {
    eval [list ${itk_hull}-itk_hull insert $index $type] $args
}
body tk++::Menu::invoke {index} {
    ${itk_hull}-itk_hull invoke $index
}
body tk++::Menu::post {x y} {
    ${itk_hull}-itk_hull post $x $y
}
body tk++::Menu::postcascade {index} {
    ${itk_hull}-itk_hull postcascade $index
}
body tk++::Menu::type {index} {
    ${itk_hull}-itk_hull type $index
}
body tk++::Menu::unpost {} {
    ${itk_hull}-itk_hull unpost
}
body tk++::Menu::yposition {index} {
    ${itk_hull}-itk_hull yposition $index
}
